<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FotoTarefaAgendService;
use FM\Traits\TResponse;


class FotoTarefaAgendController extends FMCrud{
    
    use TResponse;
    
    protected $FotoTarefaAgendService;
   
    public function __construct($crudService, $environment, FotoTarefaAgendService $FotoTarefaAgendService) {
        parent::__construct($crudService, $environment);
        $this->FotoTarefaAgendService = $FotoTarefaAgendService;
    }
   
    public function anexarFoto(DTO\Request $request, DTO\Response $response){
        try {
            $this->FotoTarefaAgendService->anexarFoto($request->getParameters());
            $this->sendResponse('success', 201);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
       
    public function getFoto(DTO\Request $request, DTO\Response $response){
        try {
            $fotos = $this->FotoTarefaAgendService->getFoto($request->getParameters());
            $this->sendResponse($fotos, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
       
    public function deleteFoto(DTO\Request $request, DTO\Response $response){
        try {
            $this->FotoTarefaAgendService->deleteFoto($request->getParameters());
            $this->sendResponse('success', 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>