/* Tabela MANUALCIA: MANUALCIA */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MANUALCIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela MANUALCIA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_MANUALCIA
AFTER DELETE OR INSERT OR UPDATE
ON MANUALCIA FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL;
      END IF;
      
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA;
      END IF;
      
      IF :OLD.CDMANCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdMancia=' || :OLD.CDMANCIA;
      END IF;
      
      IF :OLD.IDTPMANUAL IS NOT NULL THEN
         V_DESC := V_DESC || ' IdTpManual=' || :OLD.IDTPMANUAL;
      END IF;
      
      IF :OLD.DSMANUAL IS NOT NULL THEN
         V_DESC := V_DESC || ' DsManual=' || :OLD.DSMANUAL;
      END IF;
      
      IF :OLD.DTINCMANCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIncMancia=' || :OLD.DTINCMANCIA;
      END IF;
      
      IF :OLD.CDOPEMANCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOpeMancia=' || :OLD.CDOPEMANCIA;
      END IF;
      
      IF :OLD.IDSITMANCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' IdSitMancia=' || :OLD.IDSITMANCIA;
      END IF;
      
      IF :OLD.CDOPEIMPMCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdOpeImpmCia=' || :OLD.CDOPEIMPMCIA;
      END IF;
      
      IF :OLD.DTIMPMANCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtImpMancia=' || :OLD.DTIMPMANCIA;
      END IF;
      
      IF :OLD.DTINIVGMA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtIniVgMa=' || :OLD.DTINIVGMA;
      END IF;
      
      IF :OLD.DTFIMVGMA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtFimVgMa=' || :OLD.DTFIMVGMA;
      END IF;
      
      IF :OLD.IDPROTMA IS NOT NULL THEN
         V_DESC := V_DESC || ' IdProtma=' || :OLD.IDPROTMA;
      END IF;
      
      IF :OLD.DTCUSTOMAN IS NOT NULL THEN
         V_DESC := V_DESC || ' DtCustoMan=' || :OLD.DTCUSTOMAN;
      END IF;
      
      IF :OLD.DTULTATUMCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' DtUltAtuMCia=' || :OLD.DTULTATUMCIA;
      END IF;
      
      IF :OLD.IDMANUALPROD IS NOT NULL THEN
         V_DESC := V_DESC || ' IdManualProd=' || :OLD.IDMANUALPROD;
      END IF;
      
      IF :OLD.DTAPREMNGRID IS NOT NULL THEN
         V_DESC := V_DESC || ' DtApremnGrid=' || :OLD.DTAPREMNGRID;
      END IF;
      
      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDCIA || '|' || :OLD.CDMANCIA || '|' || :OLD.IDTPMANUAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL          <> :NEW.CDFILIAL   )OR
            (:OLD.CDCIA             <> :NEW.CDCIA      )OR
            (:OLD.CDMANCIA          <> :NEW.CDMANCIA   )OR
            (:OLD.IDTPMANUAL        <> :NEW.IDTPMANUAL )OR
            (:OLD.DSMANUAL          <> :NEW.DSMANUAL   )OR
            (:OLD.DTINCMANCIA       <> :NEW.DTINCMANCIA)OR
            (:OLD.CDOPEMANCIA       <> :NEW.CDOPEMANCIA)OR
            (:OLD.IDSITMANCIA       <> :NEW.IDSITMANCIA)OR
            (NVL(:OLD.CDOPEIMPMCIA, ' ')       <> NVL(:NEW.CDOPEIMPMCIA, ' '))  OR
            (NVL(:OLD.DTIMPMANCIA, SYSDATE) <> NVL(:NEW.DTIMPMANCIA, SYSDATE)) OR
            (:OLD.DTINIVGMA         <> :NEW.DTINIVGMA)OR
            (:OLD.DTFIMVGMA         <> :NEW.DTFIMVGMA)OR
            (:OLD.IDPROTMA          <> :NEW.IDPROTMA )OR
            (NVL(:OLD.DTCUSTOMAN, SYSDATE)   <> NVL(:NEW.DTCUSTOMAN, SYSDATE))  OR
            (NVL(:OLD.DTULTATUMCIA, SYSDATE) <> NVL(:NEW.DTULTATUMCIA, SYSDATE)) OR
            (:OLD.IDMANUALPROD               <> :NEW.IDMANUALPROD   )OR
            (NVL(:OLD.DTAPREMNGRID, SYSDATE) <> NVL(:NEW.DTAPREMNGRID, SYSDATE)) THEN
            
            IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
               V_DESC := V_DESC || 'CdFilial=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
            END IF;
            
            IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
               V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA || '|' || :NEW.CDCIA;
            END IF;
            
            IF NVL(:OLD.CDMANCIA, ' ') <> NVL(:NEW.CDMANCIA, ' ') THEN
               V_DESC := V_DESC || ' CdMancia=' || :OLD.CDMANCIA || '|' || :NEW.CDMANCIA;
            END IF;
            
            IF NVL(:OLD.IDTPMANUAL, ' ') <> NVL(:NEW.IDTPMANUAL, ' ') THEN
               V_DESC := V_DESC || ' IdTpManual=' || :OLD.IDTPMANUAL || '|' || :NEW.IDTPMANUAL;
            END IF;
            
            IF NVL(:OLD.DSMANUAL, ' ') <> NVL(:NEW.DSMANUAL, ' ') THEN
               V_DESC := V_DESC || ' DsManual=' || :OLD.DSMANUAL || '|' || :NEW.DSMANUAL;
            END IF;
            
            IF NVL(:OLD.DTINCMANCIA, SYSDATE) <> NVL(:NEW.DTINCMANCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtIncMancia=' || :OLD.DTINCMANCIA || '|' || :NEW.DTINCMANCIA;
            END IF;
            
            IF NVL(:OLD.CDOPEMANCIA, ' ') <> NVL(:NEW.CDOPEMANCIA, ' ') THEN
               V_DESC := V_DESC || ' CdOpeMancia=' || :OLD.CDOPEMANCIA || '|' || :NEW.CDOPEMANCIA;
            END IF;
            
            IF NVL(:OLD.IDSITMANCIA, ' ') <> NVL(:NEW.IDSITMANCIA, ' ') THEN
               V_DESC := V_DESC || ' IdSitMancia=' || :OLD.IDSITMANCIA || '|' || :NEW.IDSITMANCIA;
            END IF;
            
            IF NVL(:OLD.CDOPEIMPMCIA, ' ') <> NVL(:NEW.CDOPEIMPMCIA, ' ') THEN
               V_DESC := V_DESC || ' CdOpeImpMCia=' || :OLD.CDOPEIMPMCIA || '|' || :NEW.CDOPEIMPMCIA;
            END IF;
            
            IF NVL(:OLD.DTIMPMANCIA, SYSDATE) <> NVL(:NEW.DTIMPMANCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtImpMancia=' || :OLD.DTIMPMANCIA || '|' || :NEW.DTIMPMANCIA;
            END IF;
            
             IF NVL(:OLD.DTINIVGMA, SYSDATE) <> NVL(:NEW.DTINIVGMA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtIniVgMa=' || :OLD.DTINIVGMA || '|' || :NEW.DTINIVGMA;
            END IF;
            
            IF NVL(:OLD.DTFIMVGMA, SYSDATE) <> NVL(:NEW.DTFIMVGMA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtFimVgMa=' || :OLD.DTFIMVGMA || '|' || :NEW.DTFIMVGMA;
            END IF;
            
            IF NVL(:OLD.IDPROTMA, ' ') <> NVL(:NEW.IDPROTMA, ' ') THEN
               V_DESC := V_DESC || ' IdProtma=' || :OLD.IDPROTMA || '|' || :NEW.IDPROTMA;
            END IF;
            
            IF NVL(:OLD.DTCUSTOMAN, SYSDATE) <> NVL(:NEW.DTCUSTOMAN, SYSDATE) THEN
               V_DESC := V_DESC || ' DtCustoMan=' || :OLD.DTCUSTOMAN || '|' || :NEW.DTCUSTOMAN;
            END IF;
            
            IF NVL(:OLD.DTULTATUMCIA, SYSDATE) <> NVL(:NEW.DTULTATUMCIA, SYSDATE) THEN
               V_DESC := V_DESC || ' DtUltAtuMCia=' || :OLD.DTULTATUMCIA || '|' || :NEW.DTULTATUMCIA;
            END IF;
            
            IF NVL(:OLD.IDMANUALPROD, ' ') <> NVL(:NEW.IDMANUALPROD, ' ') THEN
               V_DESC := V_DESC || ' IdManualProd=' || :OLD.IDMANUALPROD || '|' || :NEW.IDMANUALPROD;
            END IF;
            
            IF NVL(:OLD.DTAPREMNGRID, SYSDATE) <> NVL(:NEW.DTAPREMNGRID, SYSDATE) THEN
               V_DESC := V_DESC || ' DtApremnGrid=' || :OLD.DTAPREMNGRID || '|' || :NEW.DTAPREMNGRID;
            END IF;
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL || '|' || :OLD.CDCIA || '|' || :OLD.CDMANCIA || '|' || :OLD.IDTPMANUAL;     
         END IF;
      ELSE
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
            V_DESC := V_DESC || 'CdFilial=' || :NEW.CDFILIAL;
         END IF;
         
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' CdCia=' || :NEW.CDCIA;
         END IF;
         
         IF NVL(:OLD.CDMANCIA, ' ') <> NVL(:NEW.CDMANCIA, ' ') THEN
            V_DESC := V_DESC || ' CdMancia=' || :NEW.CDMANCIA;
         END IF;
         
         IF NVL(:OLD.IDTPMANUAL, ' ') <> NVL(:NEW.IDTPMANUAL, ' ') THEN
            V_DESC := V_DESC || ' IdTpManual=' || :NEW.IDTPMANUAL;
         END IF;
         
         IF NVL(:OLD.DSMANUAL, ' ') <> NVL(:NEW.DSMANUAL, ' ') THEN
            V_DESC := V_DESC || ' DsManual=' || :NEW.DSMANUAL;
         END IF;
         
         IF NVL(:OLD.DTINCMANCIA, SYSDATE) <> NVL(:NEW.DTINCMANCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtIncMancia=' || :NEW.DTINCMANCIA;
         END IF;
         
         IF NVL(:OLD.CDOPEMANCIA, ' ') <> NVL(:NEW.CDOPEMANCIA, ' ') THEN
            V_DESC := V_DESC || ' CdOpeMancia=' || :NEW.CDOPEMANCIA;
         END IF;
         
         IF NVL(:OLD.IDSITMANCIA, ' ') <> NVL(:NEW.IDSITMANCIA, ' ') THEN
            V_DESC := V_DESC || ' IdSitMancia=' || :NEW.IDSITMANCIA;
         END IF;
         
         IF NVL(:OLD.CDOPEIMPMCIA, ' ') <> NVL(:NEW.CDOPEIMPMCIA, ' ') THEN
            V_DESC := V_DESC || ' CdOpeImpmCia=' || :NEW.CDOPEIMPMCIA;
         END IF;
         
         IF NVL(:OLD.DTIMPMANCIA, SYSDATE) <> NVL(:NEW.DTIMPMANCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtImpMancia=' || :NEW.DTIMPMANCIA;
         END IF;
         
         IF NVL(:OLD.DTINIVGMA, SYSDATE) <> NVL(:NEW.DTINIVGMA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtIniVgMa=' || :NEW.DTINIVGMA;
         END IF;
         
         IF NVL(:OLD.DTFIMVGMA, SYSDATE) <> NVL(:NEW.DTFIMVGMA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtFimVgMa=' || :NEW.DTFIMVGMA;
         END IF;
         
         IF NVL(:OLD.IDPROTMA, ' ') <> NVL(:NEW.IDPROTMA, ' ') THEN
            V_DESC := V_DESC || ' IdProtma=' || :NEW.IDPROTMA;
         END IF;
         
         IF NVL(:OLD.DTCUSTOMAN, SYSDATE) <> NVL(:NEW.DTCUSTOMAN, SYSDATE) THEN
            V_DESC := V_DESC || ' DtCustoMan=' || :NEW.DTCUSTOMAN;
         END IF;
         
         IF NVL(:OLD.DTULTATUMCIA, SYSDATE) <> NVL(:NEW.DTULTATUMCIA, SYSDATE) THEN
            V_DESC := V_DESC || ' DtUltAtuMCia=' || :NEW.DTULTATUMCIA;
         END IF;
         
         IF NVL(:OLD.IDMANUALPROD, ' ') <> NVL(:NEW.IDMANUALPROD, ' ') THEN
            V_DESC := V_DESC || ' IdManualProd=' || :NEW.IDMANUALPROD;
         END IF;
         
         IF NVL(:OLD.DTAPREMNGRID, SYSDATE) <> NVL(:NEW.DTAPREMNGRID, SYSDATE) THEN
            V_DESC := V_DESC || ' DtApremnGrid=' || :NEW.DTAPREMNGRID;
         END IF;
                  
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL || '|' || :NEW.CDCIA || '|' || :NEW.CDMANCIA || '|' || :NEW.IDTPMANUAL;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('MANUALCIA', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_MANUALCIA','5.85.xxx'); END;
/

