import {
  Http, IDictionary,
} from '@zeedhi/core';
import {} from '@zeedhi/common';

export class HierarquiasController {
  // Objeto com usuários da hierarquia
  public gridInfo: IDictionary[] = [];

  // Id's, dos usuários da ramificação abaixo do userlogado
  public lowerHierarchyUsers: IDictionary = [];

  // Busca o ID(nr) da hierarquia ativa e salva no local storage
  public getActiveHierarchyId() {
    Http.get('/getActiveHierarchyId').then((response: IDictionary) => {
      const nrhierarquiafunc = response.data.dataset.info[0].NRHIERARQUIAFUNC;
      window.localStorage.setItem('nrhierarquiafunc', nrhierarquiafunc);
    });
  }

  // Monta o array de usuários da ramificação abaixo
  public async mountHierarchyUsersArray() {
    // const id = localStorage.getItem('nrhierarquiafunc');
    const cdoperador = localStorage.getItem('CDOPERADOR'); // mandar esse userlogado na primeira chamada

    await Http.post('/getHierarquiaFacilities', {
      CDOPERADOR: cdoperador,
    }).then((response: IDictionary) => {
      this.gridInfo = [];
      response.data.forEach((database: IDictionary) => {
        this.gridInfo.push({
          userId: database.CDOPERADOR,
          userName: database.NMOPERADOR,
          userParent: database.CDOPERADORPAI,
          hierarchyId: database.NRFUNCIONARIOSHIERARQ,
        });
      });
      this.lowerHierarchyUsers = [];
    });

    this.gatherLowerHierarchyUsers(cdoperador);
    return this.lowerHierarchyUsers;
  }

  // Salva no array os usuários daquela ramificação
  public gatherLowerHierarchyUsers(CDOPERADOR: any) {
    this.lowerHierarchyUsers.push(CDOPERADOR);

    this.gridInfo.forEach((user: IDictionary) => {
      if (CDOPERADOR === user.userParent) this.gatherLowerHierarchyUsers(user.userId);
    });
  }
}
